# see https://cloud.google.com/bigquery/docs/reference/rest/v2/Job
# WRITE_TRUNCATE = overwrite
# WRITE_APPEND = append
# WRITE_EMPTY = write if empty

# overridden by MART_DAILY_SCHEDULE env variable
## 12:45pm utc (7:45am cst)
schedule: "40 12 * * *"
# overridden by MART_DAILY_DEFAULT_PARTITION_TYPE env variable
default_partition_type: DAY

starters:
  - mart: mart__course_offering__file_interaction__starter
    file: mart/course_offering/file_interaction_starter.sql
    target_dataset: mart_course_offering

  - mart: mart_course_offering__interaction_sessions__starter
    file: mart/course_offering/interaction_sessions_starter.sql
    target_dataset: mart_course_offering

  - mart: mart__course_section__file_interaction__starter
    file: mart/course_section/file_interaction_starter.sql
    target_dataset: mart_course_section

  - mart: mart_course_section__interaction_sessions__starter
    file: mart/course_section/interaction_sessions_starter.sql
    target_dataset: mart_course_section

  - mart: mart__general__lms_tool__starter
    file: mart/general/lms_tool_starter.sql
    target_dataset: mart_general

  - mart: mart__taskforce__level1_aggregated__starter
    file: mart/taskforce/level1_aggregated_starter.sql
    target_dataset: mart_taskforce

  - mart: mart__taskforce__level2_aggregated__starter
    file: mart/taskforce/level2_aggregated_starter.sql
    target_dataset: mart_taskforce

marts:
  - mart: mart__course_offering__file_interaction
    target_table: mart_course_offering.file_interaction
    file: mart/course_offering/file_interaction.sql
    write_disposition: WRITE_TRUNCATE
    partition_field: created_date
    partition_type: MONTH
    starter: mart__course_offering__file_interaction__starter
    depends_on:
      - mart_helper.event__course_offering__object_interaction
      - mart_helper.context__file
      - mart_helper.context__course_section_enrollment
      - mart_helper.context__course_offering__enrollment
      - mart_helper.context__course_offering
      - mart_helper.context__academic_term

  - mart: mart_course_offering__interaction_sessions
    target_table: mart_course_offering.interaction_sessions
    file: mart/course_offering/interaction_sessions.sql
    write_disposition: WRITE_TRUNCATE
    partition_field: session_date
    starter: mart_course_offering__interaction_sessions__starter
    depends_on:
      - mart_helper.context__course_section_enrollment
      - mart_helper.context__course_section
      - mart_helper.context__course_offering
      - mart_helper.event__course_offering__interaction_sessions
      - mart_helper.context__person
      - mart_helper.context__course_offering__enrollment
      - mart_helper.context__academic_term
      - mart_helper.context__course_offering_academic_organization

  - mart: mart__course_offering__learning_environment_organization
    target_table: mart_course_offering.learning_environment_organization
    file: mart/course_offering/learning_environment_organization.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_helper.context__course_section_enrollment
      - mart_helper.context__course_offering__enrollment
      - mart_helper.context__course_offering
      - mart_helper.context__course_section
      - mart_helper.context__person
      - mart_helper.context__academic_term
      - mart_helper.context__learning_environment_organization

  - mart: mart__course_offering__daily_course_grade_record
    target_table: mart_course_offering.daily_course_grade_record
    file: mart/course_offering/daily_course_grade_record.sql
    write_disposition: WRITE_APPEND
    partition_field: run_date
    depends_on:
      - mart_helper.context__course_grade
      - mart_helper.context__course_section
      - mart_helper.context__course_offering
      - mart_helper.context__academic_term

  - mart: mart__course_section__file_interaction
    target_table: mart_course_section.file_interaction
    file: mart/course_section/file_interaction.sql
    write_disposition: WRITE_TRUNCATE
    partition_field: created_date
    partition_type: MONTH
    starter: mart__course_section__file_interaction__starter
    depends_on:
      - mart_helper.event__course_offering__object_interaction
      - mart_helper.context__file
      - mart_helper.context__course_section_enrollment
      - mart_helper.context__course_section
      - mart_helper.context__course_section__enrollment
      - mart_helper.context__course_offering
      - mart_helper.context__academic_term

  - mart: mart_course_section__interaction_sessions
    target_table: mart_course_section.interaction_sessions
    file: mart/course_section/interaction_sessions.sql
    write_disposition: WRITE_TRUNCATE
    partition_field: session_date
    starter: mart_course_section__interaction_sessions__starter
    depends_on:
      - mart_helper.event__course_offering__interaction_sessions
      - mart_helper.context__course_offering
      - mart_helper.context__person
      - mart_helper.context__course_section
      - mart_helper.context__course_section_enrollment
      - mart_helper.context__course_section__enrollment
      - mart_helper.context__academic_term
      - mart_helper.context__academic_organization

  - mart: mart__course_section__learning_environment_organization
    target_table: mart_course_section.learning_environment_organization
    file: mart/course_section/learning_environment_organization.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_helper.context__course_section_enrollment
      - mart_helper.context__course_section__enrollment
      - mart_helper.context__course_offering
      - mart_helper.context__course_section
      - mart_helper.context__person
      - mart_helper.context__academic_term
      - mart_helper.context__learning_environment_organization

  - mart: mart__course_section__daily_course_grade_record
    target_table: mart_course_section.daily_course_grade_record
    file: mart/course_section/daily_course_grade_record.sql
    write_disposition: WRITE_APPEND
    partition_field: run_date
    depends_on:
      - mart_helper.context__course_grade
      - mart_helper.context__course_section
      - mart_helper.context__course_offering
      - mart_helper.context__academic_term

  - mart: mart__general__lms_tool
    target_table: mart_general.lms_tool
    file: mart/general/lms_tool.sql
    write_disposition: WRITE_TRUNCATE
    partition_field: event_time
    starter: mart__general__lms_tool__starter
    depends_on:
      - mart_helper.event__general__lms_tool
      - mart_helper.context__course_offering
      - mart_helper.context__academic_term
      - mart_helper.context__course_offering_academic_organization
      - mart_helper.context__person
      - mart_helper.context__course_offering__enrollment
      - mart_helper.context__course_offering_section_enrollment
      - mart_helper.context__course_section

  - mart: mart__taskforce__course_profile
    target_table: mart_taskforce.course_profile
    file: mart/taskforce/course_profile.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_helper.context__taskforce__course_profile

  - mart: mart__taskforce__student_term_profile
    target_table: mart_taskforce.student_term_profile
    file: mart/taskforce/student_term_profile.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_helper.context__taskforce__student_term_profile

  - mart: mart__taskforce__level1_aggregated
    target_table: mart_taskforce.level1_aggregated
    file: mart/taskforce/level1_aggregated.sql
    write_disposition: WRITE_TRUNCATE
    starter: mart__taskforce__level1_aggregated__starter
    depends_on:
      - mart_helper.context__taskforce__enrollments_grades_courses
      - mart_helper.context__course_offering
      - mart_helper.context__person
      - mart_helper.context__taskforce__level1_assignments_submissions
      - mart_helper.context__taskforce__weekly_discussions
      - mart_helper.event__taskforce__time_spent_view_days
      - mart_helper.event__taskforce__tool_launches
      - mart_helper.event__taskforce__file_accesses

  - mart: mart__taskforce__level2_course_week_metrics
    target_table: mart_taskforce.level2_course_week_metrics
    file: mart/taskforce/level2_course_week_metrics.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_taskforce.level1_aggregated

  - mart: mart__taskforce__level2_course_week_files
    target_table: mart_taskforce.level2_course_week_files
    file: mart/taskforce/level2_course_week_files.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_taskforce.level1_aggregated

  - mart: mart__taskforce__level2_course_week_tools
    target_table: mart_taskforce.level2_course_week_tools
    file: mart/taskforce/level2_course_week_tools.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_taskforce.level1_aggregated

  - mart: mart__taskforce__level2_course_weekly_distribution_summary
    target_table: mart_taskforce.level2_course_weekly_distribution_summary
    file: mart/taskforce/level2_course_weekly_distribution_summary.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_taskforce.level2_course_week_metrics
      - mart_taskforce.level2_course_week_files
      - mart_taskforce.level2_course_week_tools

  - mart: mart__taskforce__level2_aggregated
    target_table: mart_taskforce.level2_aggregated
    file: mart/taskforce/level2_aggregated.sql
    write_disposition: WRITE_TRUNCATE
    starter: mart__taskforce__level2_aggregated__starter
    depends_on:
      - mart_taskforce.level1_aggregated
      - mart_taskforce.level2_course_week_metrics
      - mart_taskforce.level2_course_week_tools
      - mart_taskforce.level2_course_week_files

  - mart: mart__student_activity_score__student_course_metrics
    target_table: mart_student_activity_score.student_course_metrics
    file: mart/student_activity_score/student_course_metrics.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_helper.context__student_activity_score__enrollments
      - mart_helper.context__student_activity_score__assignments
      - mart_helper.context__student_activity_score__submissions
      - mart_helper.event__student_activity_score__navigation_time
      - mart_helper.context__student_activity_score__student_term_campus
      - mart_helper.context__student_activity_score__student_term_academic_level
      - mart_helper.context__student_activity_score__student_term_program

  - mart: mart__student_activity_score__student_course_section_metrics
    target_table: mart_student_activity_score.student_course_section_metrics
    file: mart/student_activity_score/student_course_section_metrics.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_helper.context__student_activity_score__enrollments
      - mart_helper.context__student_activity_score__assignments
      - mart_helper.context__student_activity_score__submissions
      - mart_helper.event__student_activity_score__navigation_time
      - mart_helper.context__student_activity_score__student_term_campus
      - mart_helper.context__student_activity_score__student_term_academic_level
      - mart_helper.context__student_activity_score__student_term_program

  - mart: mart__student_activity_score__course_final
    target_table: mart_student_activity_score.course_final
    file: mart/student_activity_score/course_final.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_student_activity_score.student_course_metrics

  - mart: mart__student_activity_score__course_section_final
    target_table: mart_student_activity_score.course_section_final
    file: mart/student_activity_score/course_section_final.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_student_activity_score.student_course_section_metrics

  - mart: mart__student_activity_score__final
    target_table: mart_student_activity_score.final
    file: mart/student_activity_score/final.sql
    write_disposition: WRITE_TRUNCATE
    depends_on:
      - mart_student_activity_score.student_course_metrics
